import pathlib
import compas
from compas_cra.viewers import cra_view
from compas_cra.equilibrium import rbe_solve, cra_solve, cra_penalty_solve
from compas_cra.algorithms import assembly_interfaces_numpy
import numpy as np
import copy
#from viewer import viewer, TMAX, AMIN, DENSITY
#from my_cra_solve import cra_penalty_solve

def main():
    folder = pathlib.Path(__file__).parent.resolve()
    assy = compas.json_load(str(folder) + "\\shell_fingers.json")
    print(str(folder) + "\\shell_fingers.json")
    # for block in range(6):
    #     assy.graph.node_attribute(block, "is_support", True)

    #cra_view(assy)

    blocks_to_use = [0, 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17]
    base = [0, 1,2,5]

    for block in base:
        assy.graph.node_attribute(block, "is_support", True)

    blocks_in_json = list(range(assy.number_of_blocks()))

    blocks_to_remove = list(set(blocks_in_json).difference(set(blocks_to_use)))
    assy.delete_blocks(blocks_to_remove)

    # print("Full shell")
    assembly_interfaces_numpy(assy, nmax=6, amin=1e-15, tmax = 1e-2)
    # cra_view(assy)
    # try:
    #     cra_view(assy)
    # except:
    #     print("Can't view... press ENTER")
    #     input()
    #     pass
    assy1 = copy.deepcopy(assy)
    assy2 = copy.deepcopy(assy)
    assy3 = copy.deepcopy(assy)
    assy4 = copy.deepcopy(assy)
    assy5 = copy.deepcopy(assy)
    assy6 = copy.deepcopy(assy)

    cra_penalty_solve(assy1, mu=1.0, d_bnd=1e-1, density=0.1, timer=True, verbose=True)
    compas.json_dump(assy1, str(folder) + "\\arch_cra_full_fingers.json")
    #cra_view(assy1)

    assy2.delete_blocks([16])
    cra_penalty_solve(assy2, mu=1.0, d_bnd=1e-1, density=0.1, timer=True, verbose=True)
    compas.json_dump(assy2, str(folder) + "\\arch_cra_1_fingers.json")
    #cra_view(assy2)

    assy3.delete_blocks([17,16,15])
    cra_penalty_solve(assy3, mu=1.0, d_bnd=1e-1, density=0.1, timer=True, verbose=True)
    compas.json_dump(assy3, str(folder) + "\\arch_cra_2_fingers.json")

    assy4.delete_blocks([17,16,15,14,13])
    cra_penalty_solve(assy4, mu=1.0, d_bnd=1e-1, density=0.1, timer=True, verbose=True)
    compas.json_dump(assy4, str(folder) + "\\arch_cra_3_fingers.json")

    assy5.delete_blocks([17,16,15,14,13,12,11])
    cra_penalty_solve(assy5, mu=1.0, d_bnd=1e-1, density=0.1, timer=True, verbose=True)
    compas.json_dump(assy5, str(folder) + "\\arch_cra_4_fingers.json")

    assy6.delete_blocks([17,16,15,14,13,12,11,10,9])
    cra_penalty_solve(assy6, mu=1.0, d_bnd=1e-1, density=0.1, timer=True, verbose=True)
    compas.json_dump(assy6, str(folder) + "\\arch_cra_5_fingers.json")
   
    #viewer(assy2)


if __name__ == '__main__':
    main()